
U++ - Bug #351

App hangs after Draw refactoring

11/13/2012 11:44 AM - Massimo Del Fedele

Status: Approved Start date: 11/13/2012

Priority: High Due date:

Assignee: Miroslav Fidler % Done: 0%

Category: Estimated time: 0.00 hour

Target version: Spent time: 0.00 hour

Description

After updating uppsrc from svn (with draw refactoring) my app hangs randomly but often.

Here a full backtrace of hanging app :

THREADS :

(gdb) info thread

  Id   Target Id         Frame 

  5    Thread 0x7fffd7142700 (LWP 23372) "TimberStruct" lll_lock_wait ()

    at ../nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S:132

  4    Thread 0x7fffd7df7700 (LWP 23366) "TimberStruct" 

    0x00007ffff604152d in nanosleep () at ../sysdeps/unix/syscall-template.S:82

  2    Thread 0x7fffdef12700 (LWP 23364) "gdbus" 0x00007ffff5118303 in __GI_poll (fds=<optimized out>, nfds=<optimized out>,

timeout=<optimized out>)

    at ../sysdeps/unix/sysv/linux/poll.c:87

    -  1    Thread 0x7ffff7fc18c0 (LWP 23361) "TimberStruct" 0x00007ffff5118303 in GI_poll (fds=<optimized out>, nfds=<optimized out>,

timeout=<optimized out>)

    at ../sysdeps/unix/sysv/linux/poll.c:87

---------------------------------------------------------------

THREAD #1

(gdb) bt

#0  0x00007ffff5118303 in GIpoll (fds=<optimized out>, 

    nfds=<optimized out>, timeout=<optimized out>)

    at ../sysdeps/unix/sysv/linux/poll.c:87

#1  0x00007ffff27c2972 in ?? () from /usr/lib/x86_64-linux-gnu/libxcb.so.1

#2  0x00007ffff27c3e47 in ?? () from /usr/lib/x86_64-linux-gnu/libxcb.so.1

#3  0x00007ffff27c406b in xcb_wait_for_reply ()

   from /usr/lib/x86_64-linux-gnu/libxcb.so.1

#4  0x00007ffff6992289 in _XReply () from /usr/lib/x86_64-linux-gnu/libX11.so.6

#5  0x00007ffff698dd3d in XSync () from /usr/lib/x86_64-linux-gnu/libX11.so.6

#6  0x000000000062b911 in Upp::Ctrl::TimerAndPaint ()

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/X11Wnd.cpp:341

#7  0x000000000062bec0 in Upp::Ctrl::EventLoop0 (ctrl=0x7fffffffb710)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/X11Wnd.cpp:435

#8  0x0000000000612128 in operator() (this=0x7fffffffa958)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Cbgen.h:32

#9  Upp::Ctrl::Call (cb=...)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlMt.cpp:132

#10 0x000000000061245d in Upp::Ctrl::EventLoop (ctrl=0x7fffffffb710)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlMt.cpp:231

#11 0x0000000000621eac in Upp::TopWindow::Run (this=0x7fffffffb710, 

    appmodal=<optimized out>)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/TopWindow.cpp:327

#12 0x0000000000418a16 in GuiMainFn ()
    at /home/massimo/sources/upp-svn/TimberStruct/TimberStruct/TimberStruct.cpp:975

#13 0x000000000069f73e in Upp::AppExecute__ (app=<optimized out>)

    at /home/massimo/sources/upp-svn/uppsrc/Core/App.cpp:322

#14 0x0000000000409d32 in main (argc=<optimized out>, argv=<optimized out>, 

    envptr=<optimized out>)

    at /home/massimo/sources/upp-svn/TimberStruct/TimberStruct/TimberStruct.cpp:828

---------------------------------------------------------------

THREAD #2

#0  0x00007ffff5118303 in GI_poll (fds=<optimized out>, 

    nfds=<optimized out>, timeout=<optimized out>)

    at ../sysdeps/unix/sysv/linux/poll.c:87

#1  0x00007ffff3c8ad84 in ?? () from /lib/x86_64-linux-gnu/libglib-2.0.so.0

#2  0x00007ffff3c8b1e2 in g_main_loop_run ()

   from /lib/x86_64-linux-gnu/libglib-2.0.so.0

#3  0x00007ffff447b3b6 in ?? () from /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0

#4  0x00007ffff3cae645 in ?? () from /lib/x86_64-linux-gnu/libglib-2.0.so.0

#5  0x00007ffff6039e9a in start_thread (arg=0x7fffdef12700)

    at pthread_create.c:308

#6  0x00007ffff5123cbd in clone ()

    at ../sysdeps/unix/sysv/linux/x86_64/clone.S:112

#7  0x0000000000000000 in ?? ()

---------------------------------------------------------------

THREAD #4

#0  0x00007ffff604152d in nanosleep () at ../sysdeps/unix/syscall-template.S:82

#1  0x00000000006b18ee in Upp::Sleep (msec=<optimized out>)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Util.cpp:173

#2  0x00000000004d6f29 in Upp::Uniq::pollCb (this=0x7fffffffabd0)

    at /home/massimo/sources/upp-svn/bazaar/Uniq/Posix.cpp:67

#3  0x000000000068a96a in operator() (this=0x7fffdc3d1840)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Cbgen.h:32

#4  Upp::sThreadRoutine (arg=0x7fffdc3d1840)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Mt.cpp:75

#5  0x00007ffff6039e9a in start_thread (arg=0x7fffd7df7700)

    at pthread_create.c:308

#6  0x00007ffff5123cbd in clone ()

    at ../sysdeps/unix/sysv/linux/x86_64/clone.S:112

#7  0x0000000000000000 in ?? ()

---------------------------------------------------------------

THREAD #5

#0  __lll_lock_wait ()

    at ../nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S:132

#1  0x00007ffff603c080 in _L_lock_903 ()

   from /lib/x86_64-linux-gnu/libpthread.so.0

#2  0x00007ffff603bf19 in __pthread_mutex_lock (

    mutex=0x1fcec68 <Upp::sGLock+8>) at pthread_mutex_lock.c:82

#3  0x0000000000611f06 in Upp::EnterGuiMutex ()

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlMt.cpp:58

#4  0x00000000006166d1 in GuiLock (this=<synthetic pointer>)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlCore.h:37

#5  Upp::Ctrl::GetView (this=0x7fffd7345e70)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlPos.cpp:62

#6  0x000000000061673a in Upp::Ctrl::GetSize (this=<optimized out>)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlCore/CtrlPos.cpp:68
#7  0x000000000046c8de in Upp::ArrayCtrl::SyncLineCtrls (

    this=this@entry=0x7fffd7345e70, i=i@entry=0, p=p@entry=0x0)

    at /home/massimo/sources/upp-svn/uppsrc/CtrlLib/ArrayCtrl.cpp:643

#8  0x000000000046d193 in Upp::ArrayCtrl::GetCtrl (this=0x7fffd7345e70, i=0, 

    col=4) at /home/massimo/sources/upp-svn/uppsrc/CtrlLib/ArrayCtrl.cpp:251

#9  0x00000000007dc6a4 in InternalForcesCtrl::GetLoadCases (

    this=0x7fffd7345ca8)

    at /home/massimo/sources/upp-svn/TimberStruct/TimberControls/Forces.cpp:267

#10 0x00000000004de21c in JointInternalPlate1::Calculate (this=0x7fffd733d028)

    at /home/massimo/sources/upp-svn/TimberStruct/TimberJoints/JointInternalPlate1.cpp:721

#11 0x00000000004b8a16 in Page::CalcThreadCb (this=0x7fffd733d028)

    at /home/massimo/sources/upp-svn/TimberStruct/TimberGui/Page.cpp:167

#12 0x000000000068a96a in operator() (this=0x7fffdc40a840)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Cbgen.h:32

#13 Upp::sThreadRoutine (arg=0x7fffdc40a840)

    at /home/massimo/sources/upp-svn/uppsrc/Core/Mt.cpp:75

#14 0x00007ffff6039e9a in start_thread (arg=0x7fffd7142700)

    at pthread_create.c:308

#15 0x00007ffff5123cbd in clone ()

    at ../sysdeps/unix/sysv/linux/x86_64/clone.S:112

#16 0x0000000000000000 in ?? ()

History

#1 - 11/13/2012 11:59 AM - Massimo Del Fedele

- Priority changed from Normal to High

#2 - 11/19/2012 01:01 PM - Miroslav Fidler

- Status changed from New to Approved
